/*
 *  TOPPERS/HRP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      High Reliable system Profile Kernel
 * 
 *  Copyright (C) 2007 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id: sh7750r_config.h 2106 2011-06-21 13:46:09Z ertl-honda $
 */

/*
 *		ץå¸⥸塼SH7750Rѡ
 *
 *  Υ󥯥롼ɥեϡtarget_config.hʤޤϡ饤
 *  롼ɤեˤΤߤ饤󥯥롼ɤ롥¾Υե뤫
 *  ľܥ󥯥롼ɤƤϤʤʤ
 */

#ifndef TOPPERS_SH7750R_CONFIG_H
#define TOPPERS_SH7750R_CONFIG_H

/*
 * ץåμ
 */
#define SH4

#ifdef FPU_ENABLE
/*
 *  FPSCRPRӥåȤν
 */
#ifdef FPU_DOUBLE
#define FPSCR_PR_INIT 0x00080000  /*  */
#else  /* FPU_SINGLE FPU_SINGLE_ONLY */
#define FPSCR_PR_INIT 0x0000000   /* ñ */
#endif /* FPU_DOUBLE */

/*
 *  FPSCRPRӥåȰʳ
 */
#ifndef FPSCR_INIT
#define FPSCR_INIT 0x00040000
#endif  /* FPSCR_INIT */
#endif /* FPU_ENABLE */

/*
 * ߥϥɥֹ˴ؤ
 */ 
#define TMIN_INHNO 0x1C0U
#define TMAX_INHNO 0xB80U
#define TNUM_INH   0x05DU

/*
 * ֹ˴ؤ
 */ 
#define TMIN_INTNO 0x1C0U
#define TMAX_INTNO 0xB80U
#define TNUM_INT   0x05DU

/*
 * ߥϥɥֹɽѴ
 */
#define EXT_INHNO(iintno) (CAST(uint16_t, (iinhno) << 5)) /* ɽɽ */
#define INT_INHNO(intno)  (CAST(uint16_t, (inhno) >> 5))  /* ɽɽ */

/*
 * ֹɽѴ
 */
#define EXT_INTNO(iintno)   (CAST(uint16_t, (iintno) << 5)) /* ɽɽ */
#define INT_INTNO(intno)    (CAST(uint16_t, (intno) >> 5))  /* ɽɽ */

/*
 * ֥ǳֹ椫 inh_tbl Υޥ
 * regˤϡֹݻƤ
 * 쥸ꤹ 
 */
#ifdef TOPPERS_ASM_MACRO
.macro index_intno reg
    shlr2 \reg
    shlr  \reg
.endm
#endif /* TOPPERS_ASM_MACRO */
     
/*
 * CPU㳰ϥɥֹ˴ؤ
 */ 
#define TMIN_EXCNO 0x040U
#define TMAX_EXCNO 0x820U
#define TNUM_EXC   0x42U
     
/*
 * CPU㳰ϥɥֹɽѴ
 */
#define EXT_EXCNO(iexcno)  (CAST(uint16_t, (iexcno) << 5)) /* ɽɽ */
#define INT_EXCNO(excno)   (CAST(uint16_t, (excno)  >> 5)) /* ɽɽ */

/*
 * ֥CPU㳰ֹ椫 exch_tbl Υޥ
 * regˤϡEXPEVT쥸ͤݻƤ
 * 쥸ꤹ 
 */
#ifdef TOPPERS_ASM_MACRO
.macro index_excno reg
    shlr2 \reg
    shlr  \reg
.endm
#endif /* TOPPERS_ASM_MACRO */

#ifndef TOPPERS_MACRO_ONLY

/*
 * ׵饤ͥ쥸
 */
#define IPR_INFO_TBL_DATA \
    {0U, 0},        /* 0x000(0x000) */ \
    {0U, 0},        /* 0x020(0x001) */ \
    {0U, 0},        /* 0x040(0x002) */ \
    {0U, 0},        /* 0x060(0x003) */ \
    {0U, 0},        /* 0x080(0x004) */ \
    {0U, 0},        /* 0x0A0(0x005) */ \
    {0U, 0},        /* 0x0C0(0x006) */ \
    {0U, 0},        /* 0x0E0(0x007) */ \
    {0U, 0},        /* 0x100(0x008) */ \
    {0U, 0},        /* 0x120(0x009) */ \
    {0U, 0},        /* 0x140(0x00A) */ \
    {0U, 0},        /* 0x160(0x00B) */ \
    {0U, 0},        /* 0x180(0x00C) */ \
    {0U, 0},        /* 0x1A0(0x00D) */ \
\
    {0U, 0},        /* 0x1C0(0x00E) NMI */ \
\
    {0U, 0},        /* 0x1E0(0x00F) */ \
\
    {0U, 0},        /* 0x200(0x010) IRL 0000 */ \
    {0U, 0},        /* 0x220(0x011) IRL 0001 */ \
    {0U, 0},        /* 0x240(0x012) IRL 0010 */ \
    {0U, 0},        /* 0x260(0x013) IRL 0011 */ \
    {0U, 0},        /* 0x280(0x014) IRL 0100 */ \
    {0U, 0},        /* 0x2A0(0x015) IRL 0101 */ \
    {0U, 0},        /* 0x2C0(0x016) IRL 0110 */ \
    {0U, 0},        /* 0x2E0(0x017) IRL 0111 */ \
    {0U, 0},        /* 0x300(0x018) IRL 1000 */ \
    {0U, 0},        /* 0x320(0x019) IRL 1001 */ \
    {0U, 0},        /* 0x340(0x01A) IRL 1010 */ \
    {0U, 0},        /* 0x360(0x01B) IRL 1011 */ \
    {0U, 0},        /* 0x380(0x01C) IRL 1100 */ \
    {0U, 0},        /* 0x3A0(0x01D) IRL 1101 */ \
    {0U, 0},        /* 0x3C0(0x01E) IRL 1110 */ \
\
    {0U, 0},        /* 0x3E0(0x01F) */ \
\
    {IPRA, 12},     /* 0x400(0x020) TUNI0 */ \
    {IPRA,  8},     /* 0x420(0x021) TUNI1 */ \
    {IPRA,  4},     /* 0x440(0x022) TUNI2 */ \
    {IPRA,  4},     /* 0x460(0x023) TICPI2*/ \
\
    {IPRA,  0},     /* 0x480(0x024) RTC  ATI */ \
    {IPRA,  0},     /* 0x4A0(0x025)      PRI */ \
    {IPRA,  0},     /* 0x4C0(0x026)      CUI */ \
\
    {IPRB,  4},     /* 0x4E0(0x027) SCI  ERI */ \
    {IPRB,  4},     /* 0x500(0x028)      RXI */ \
    {IPRB,  4},     /* 0x520(0x029)      TXI */ \
    {IPRB,  4},     /* 0x540(0x02A)      TEI */ \
\
    {IPRB, 12},     /* 0x560(0x02B) WDT  ITI */ \
\
    {IPRB,  8},     /* 0x580(0x02C) REF  RCMI */ \
    {IPRB,  8},     /* 0x5A0(0x02D)      ROVI */ \
\
    {0U, 0},        /* 0x5C0(0x02E) */ \
    {0U, 0},        /* 0x5E0(0x02F) */ \
\
    {IPRC,  0},     /* 0x600(0x030) H-UDI H-UDII */ \
\
    {IPRC, 12},     /* 0x620(0x031) GPIO  GPIOI */ \
\
    {IPRC,  8},     /* 0x640(0x032) DMAC DMINT0 */ \
    {IPRC,  8},     /* 0x660(0x033)      DMINT1 */ \
    {IPRC,  8},     /* 0x680(0x034)      DMINT2 */ \
    {IPRC,  8},     /* 0x6A0(0x035)      DMINT3 */ \
    {IPRC,  8},     /* 0x6C0(0x036)      DMAE   */ \
\
    {0U, 0},        /* 0x6E0(0x037)             */ \
\
    {IPRC,  4},     /* 0x700(0x038) SCIF ERI */ \
    {IPRC,  4},     /* 0x720(0x039)      RXI */ \
    {IPRC,  4},     /* 0x740(0x03A)      BRI */ \
    {IPRC,  4},     /* 0x760(0x03B)      TXI */ \
\
    {IPRC,  8},     /* 0x780(0x03C) DMAC DMTE4 */ \
    {IPRC,  8},     /* 0x7A0(0x03D)      DMTE5 */ \
    {IPRC,  8},     /* 0x7C0(0x03E)      DMTE6 */ \
    {IPRC,  8},     /* 0x7E0(0x03F)      DMTE7 */ \
\
    {0U, 0},        /* 0x800(0x040) */ \
    {0U, 0},        /* 0x820(0x041) */ \
    {0U, 0},        /* 0x840(0x042) */ \
    {0U, 0},        /* 0x860(0x043) */ \
    {0U, 0},        /* 0x880(0x044) */ \
    {0U, 0},        /* 0x8A0(0x045) */ \
    {0U, 0},        /* 0x8C0(0x046) */ \
    {0U, 0},        /* 0x8E0(0x047) */ \
    {0U, 0},        /* 0x900(0x048) */ \
    {0U, 0},        /* 0x920(0x049) */ \
    {0U, 0},        /* 0x940(0x04A) */ \
    {0U, 0},        /* 0x960(0x04B) */ \
    {0U, 0},        /* 0x980(0x04C) */ \
    {0U, 0},        /* 0x9A0(0x04D) */ \
    {0U, 0},        /* 0x9C0(0x04E) */ \
    {0U, 0},        /* 0x9E0(0x04F) */ \
    {0U, 0},        /* 0xA00(0x050) */ \
    {0U, 0},        /* 0xA20(0x051) */ \
    {0U, 0},        /* 0xA40(0x052) */ \
    {0U, 0},        /* 0xA60(0x053) */ \
    {0U, 0},        /* 0xA80(0x054) */ \
    {0U, 0},        /* 0xAA0(0x055) */ \
    {0U, 0},        /* 0xAC0(0x056) */ \
    {0U, 0},        /* 0xAE0(0x057) */ \
\
    {INTPRI00, 8}, /* 0xB00(0x058) TMU3 TUNI3 */ \
\
    {0U, 0},        /* 0xB20(0x059) */ \
    {0U, 0},        /* 0xB40(0x05A) */ \
    {0U, 0},        /* 0xB60(0x05B) */ \
\
    {INTPRI00, 12}, /* 0xB80(0x05C) TMU4 TUNI4 */ \

/*
 * IRCν
 */
Inline void
init_irc(void)
{
    sil_wrh_mem((void*)ICR,  0x0000);
    sil_wrh_mem((void*)IPRA, 0x0000);
    sil_wrh_mem((void*)IPRB, 0x0000);
    sil_wrh_mem((void*)IPRC, 0x0000);
    sil_wrh_mem((void*)IPRD, 0xDA74);
    sil_wrw_mem((void*)INTPRI00, 0x00000000);
    sil_wrw_mem((void*)INTMSK00, 0x00000300);

    /* ߥޥ򥯥ꥢ */
    sil_wrw_mem((void*)INTMSKCR, 0xFFFFFFFFU);
}

/*
 * ͥ٥쥸
 */
Inline void
set_irc_ipr(uint32_t address, uint32_t offset, uint8_t val)
{
    uint16_t ipr_val;
    
    ipr_val = sil_reh_mem((void *) address);
    ipr_val &= ~(0x0FU << offset);
    ipr_val |= (uint16_t)val << offset;    
    sil_wrh_mem((void *) address, ipr_val);
}

#endif /* TOPPERS_MACRO_ONLY */

/*
 *  ץå¸⥸塼SH34ѡ
 */
#include "sh34_gcc/prc_config.h"

#endif /* TOPPERS_SH7750R_CONFIG_H */
