/*
 *  TOPPERS Software
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 * 
 *  Copyright (C) 2012 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  $Id: test_tex6.c 837 2012-12-26 15:09:59Z ertl-hiro $
 */

/* 
 *		㳰˴ؤƥ(6)
 *
 * ڥƥȤŪ
 *
 *  桼ɥᥤ°륿ФơCPUå֤βunl_cpu
 *  ȳĥӥ롼󤫤Υ꥿ˤ륿㳰롼
 *  μ¹ԳϽŪ˥ƥȤ롥ƥȤƤϡ㳰
 *  ˴ؤƥ(5)Ʊ
 *
 * ڥƥȹܡ
 *
 *	(A) CPUå֤βˤ륿㳰롼μ¹Գ
 *		(A-1) 7郎·äơ㳰롼󤬼¹Գ
 *	(B) CPUå֤β·ʤ郎ꡤ㳰롼
 *		󤬼¹ԳϤʤ
 *		(B-1) оݥ㳰ػ߾
 *		(B-2) оݥα㳰װ0
 *		(B-3) оݥ¹Ծ֤Ǥʤ
 *		(B-4) ͥ٥ޥ֤Ǥʤ
 *		(B-5) оݥ㳰ޥ֡ʳĥӥ
 *			  ¹ԤƤ֡
 *	(C) ĥӥ롼󤫤Υ꥿ˤ륿㳰롼
 *		μ¹Գ
 *		(C-1) 7郎·äơ㳰롼󤬼¹Գ
 *	(D) ĥӥ롼󤫤Υ꥿·ʤ郎
 *		ꡤ㳰롼󤬼¹ԳϤʤ
 *		(D-1) оݥ㳰ػ߾
 *		(D-2) оݥα㳰װ0
 *		(D-3) оݥ¹Ծ֤Ǥʤ
 *		(D-4) 󥿥ƥȤ¹ԤƤ
 *		(D-5) ͥ٥ޥ֤Ǥʤ
 *		(D-6) CPUå֤Ǥ
 *		(D-7) оݥ㳰ޥ֡ʳĥӥ
 *			  ¹ԤƤ֡
 *
 * ڻѥ꥽
 *
 *	TASK1: ᥤΥCPUå֤βԤ
 *	TASK2: оݥ¹Ծ֤ǤʤƥȤ뤿Υ
 *	CPUEXC: CPU㳰ϥɥ
 *	EXTSVC1: ĥӥ1
 *	EXTSVC2: ĥӥ2
 *
 * ڥƥȥ󥹡
 *
 *	== TASK1ͥ١10==
 *	1:	cal_svc(TFN_EXTSVC1, 0, 0, 0, 0, 0)
 *	== EXTSVC1-11ܡ==
 *	2:	ena_tex()
 *		ras_tex(TSK_SELF, 0x0001)
 *		chg_ipm(TIPM_ENAALL)
 *		loc_cpu()
 *	3:	unl_cpu()								... (B-5)
 *	4:	loc_cpu()
 *	5:	RETURN(E_OK)							... (D-6)
 *	== TASK1³==
 *	6:	unl_cpu()								... (A-1)
 *	== TASK1-TEX-11ܡ==
 *	7:	assert(texptn == 0x0001)
 *		state(false, false, TIPM_ENAALL, false, false, true)
 *		RETURN
 *	== TASK1³==
 *	8:	cal_svc(TFN_EXTSVC1, 0, 0, 0, 0, 0)
 *	== EXTSVC1-22ܡ==
 *	9:	ena_tex()
 *		chg_ipm(TIPM_ENAALL)
 *		loc_cpu()
 *		RETURN(E_OK)
 *	== TASK1³==
 *	10:	unl_cpu()								... (B-2)
 *	11:	cal_svc(TFN_EXTSVC1, 0, 0, 0, 0, 0)
 *	== EXTSVC1-33ܡ==
 *	12:	dis_tex()
 *		ras_tex(TSK_SELF, 0x0002)
 *		chg_ipm(TIPM_ENAALL)
 *		loc_cpu()
 *		RETURN(E_OK)
 *	== TASK1³==
 *	13:	unl_cpu()								... (B-1)
 *	14:	cal_svc(TFN_EXTSVC1, 0, 0, 0, 0, 0)
 *	== EXTSVC1-44ܡ==
 *	15:	ena_tex()
 *		ras_tex(TSK_SELF, 0x0004)
 *		chg_ipm(TMAX_INTPRI)
 *		loc_cpu()
 *		RETURN(E_OK)
 *	== TASK1³==
 *	16:	unl_cpu()								... (B-4)
 *		chg_ipm(TIPM_ENAALL)
 *	== TASK1-TEX-22ܡ==
 *	17:	assert(texptn == 0x0006)
 *		state(false, false, TIPM_ENAALL, false, false, true)
 *		RETURN
 *	== TASK1³==
 *	18:	act_tsk(TASK2)
 *		slp_tsk()
 *	== TASK2ͥ١11==
 *	19:	ena_tex()
 *		wup_tsk(TASK1)
 *	== TASK1³==
 *	20:	ras_tex(TASK2, 0x0008)
 *		loc_cpu()
 *	21:	unl_cpu()								... (B-3)
 *	22:	cal_svc(TFN_EXTSVC1, 0, 0, 0, 0, 0)
 *	== EXTSVC1-55ܡ==
 *	23:	RETURN(E_OK)							... (D-3)
 *	== TASK1³==
 *	24:	cal_svc(TFN_EXTSVC1, 0, 0, 0, 0, 0)
 *	== EXTSVC1-66ܡ==
 *	25:	ena_tex()
 *		ras_tex(TSK_SELF, 0x0010)
 *		chg_ipm(TIPM_ENAALL)
 *	26:	RETURN(E_OK)							... (C-1)(D-3)
 *	== TASK1-TEX-33ܡ==
 *	27:	assert(texptn == 0x0010)
 *		state(false, false, TIPM_ENAALL, false, false, true)
 *		RETURN
 *	== TASK1³==
 *	28:	cal_svc(TFN_EXTSVC1, 0, 0, 0, 0, 0)
 *	== EXTSVC1-77ܡ==
 *	29:	ena_tex()
 *		chg_ipm(TIPM_ENAALL)
 *	30:	RETURN(E_OK)							... (D-2)
 *	== TASK1³==
 *	31:	cal_svc(TFN_EXTSVC1, 0, 0, 0, 0, 0)
 *	== EXTSVC1-88ܡ==
 *	32:	dis_tex()
 *		ras_tex(TSK_SELF, 0x0020)
 *		chg_ipm(TIPM_ENAALL)
 *	33:	RETURN(E_OK)							... (D-1)
 *	== TASK1³==
 *	34:	cal_svc(TFN_EXTSVC1, 0, 0, 0, 0, 0)
 *	== EXTSVC1-99ܡ==
 *	35:	ena_tex()
 *		ras_tex(TSK_SELF, 0x0040)
 *		chg_ipm(TMAX_INTPRI)
 *	36:	RETURN(E_OK)							... (D-5)
 *	== TASK1³==
 *	37:	cal_svc(TFN_EXTSVC2, 0, 0, 0, 0, 0)
 *	== EXTSVC2-11ܡ==
 *	38:	cal_svc(TFN_EXTSVC1, 0, 0, 0, 0, 0)
 *	== EXTSVC1-1010ܡ==
 *	39:	ena_tex()
 *		ras_tex(TSK_SELF, 0x0080)
 *		chg_ipm(TIPM_ENAALL)
 *	40:	RETURN(E_OK)							... (D-7)
 *	== EXTSVC2-1³==
 *	41:	RETURN(E_OK)
 *	== TASK1-TEX-44ܡ==
 *	42:	assert(texptn == 0x00e0)
 *		state(false, false, TIPM_ENAALL, false, false, true)
 *		RETURN
 *	== TASK1³==
 *	43:	ena_tex()
 *		chg_ipm(TIPM_ENAALL)
 *		DO(RAISE_CPU_EXCEPTION)
 *	== CPUEXC ==
 *	44:	cal_svc(TFN_EXTSVC1, 0, 0, 0, 0, 0)
 *	== EXTSVC1-1111ܡ==
 *	45:	iras_tex(TASK1, 0x0100)
 *	46:	RETURN(E_OK)							... (D-4)
 *	== CPUEXC³==
 *	47:	RETURN
 *	== TASK1-TEX-55ܡ==
 *	48:	assert(texptn == 0x0100)
 *		state(false, false, TIPM_ENAALL, false, false, true)
 *	49:	ext_tsk()
 *	== TASK2-TEX ==
 *	50:	assert(texptn == 0x0008)
 *		state(false, false, TIPM_ENAALL, false, false, true)
 *	51:	END
 */

#include <kernel.h>
#include <test_lib.h>
#include <t_syslog.h>
#include "kernel_cfg.h"
#include "test_tex6.h"

void
cpuexc_handler(void *p_excinf)
{
	ER		ercd;

	check_point(44);

	ercd = cal_svc(TFN_EXTSVC1, 0, 0, 0, 0, 0);
	check_ercd(ercd, E_OK);

	check_point(47);

	return;

	check_point(0);
}

static uint_t	extsvc1_count = 0;

ER_UINT
extsvc1_routine(intptr_t par1, intptr_t par2, intptr_t par3,
								intptr_t par4, intptr_t par5, ID cdmid)
{
	ER		ercd;

	switch (++extsvc1_count) {
	case 1:
		check_point(2);

		ercd = ena_tex();
		check_ercd(ercd, E_OK);

		ercd = ras_tex(TSK_SELF, 0x0001);
		check_ercd(ercd, E_OK);

		ercd = chg_ipm(TIPM_ENAALL);
		check_ercd(ercd, E_OK);

		ercd = loc_cpu();
		check_ercd(ercd, E_OK);

		check_point(3);

		ercd = unl_cpu();
		check_ercd(ercd, E_OK);

		check_point(4);

		ercd = loc_cpu();
		check_ercd(ercd, E_OK);

		check_point(5);

		return(E_OK);

		check_point(0);

	case 2:
		check_point(9);

		ercd = ena_tex();
		check_ercd(ercd, E_OK);

		ercd = chg_ipm(TIPM_ENAALL);
		check_ercd(ercd, E_OK);

		ercd = loc_cpu();
		check_ercd(ercd, E_OK);

		return(E_OK);

		check_point(0);

	case 3:
		check_point(12);

		ercd = dis_tex();
		check_ercd(ercd, E_OK);

		ercd = ras_tex(TSK_SELF, 0x0002);
		check_ercd(ercd, E_OK);

		ercd = chg_ipm(TIPM_ENAALL);
		check_ercd(ercd, E_OK);

		ercd = loc_cpu();
		check_ercd(ercd, E_OK);

		return(E_OK);

		check_point(0);

	case 4:
		check_point(15);

		ercd = ena_tex();
		check_ercd(ercd, E_OK);

		ercd = ras_tex(TSK_SELF, 0x0004);
		check_ercd(ercd, E_OK);

		ercd = chg_ipm(TMAX_INTPRI);
		check_ercd(ercd, E_OK);

		ercd = loc_cpu();
		check_ercd(ercd, E_OK);

		return(E_OK);

		check_point(0);

	case 5:
		check_point(23);

		return(E_OK);

		check_point(0);

	case 6:
		check_point(25);

		ercd = ena_tex();
		check_ercd(ercd, E_OK);

		ercd = ras_tex(TSK_SELF, 0x0010);
		check_ercd(ercd, E_OK);

		ercd = chg_ipm(TIPM_ENAALL);
		check_ercd(ercd, E_OK);

		check_point(26);

		return(E_OK);

		check_point(0);

	case 7:
		check_point(29);

		ercd = ena_tex();
		check_ercd(ercd, E_OK);

		ercd = chg_ipm(TIPM_ENAALL);
		check_ercd(ercd, E_OK);

		check_point(30);

		return(E_OK);

		check_point(0);

	case 8:
		check_point(32);

		ercd = dis_tex();
		check_ercd(ercd, E_OK);

		ercd = ras_tex(TSK_SELF, 0x0020);
		check_ercd(ercd, E_OK);

		ercd = chg_ipm(TIPM_ENAALL);
		check_ercd(ercd, E_OK);

		check_point(33);

		return(E_OK);

		check_point(0);

	case 9:
		check_point(35);

		ercd = ena_tex();
		check_ercd(ercd, E_OK);

		ercd = ras_tex(TSK_SELF, 0x0040);
		check_ercd(ercd, E_OK);

		ercd = chg_ipm(TMAX_INTPRI);
		check_ercd(ercd, E_OK);

		check_point(36);

		return(E_OK);

		check_point(0);

	case 10:
		check_point(39);

		ercd = ena_tex();
		check_ercd(ercd, E_OK);

		ercd = ras_tex(TSK_SELF, 0x0080);
		check_ercd(ercd, E_OK);

		ercd = chg_ipm(TIPM_ENAALL);
		check_ercd(ercd, E_OK);

		check_point(40);

		return(E_OK);

		check_point(0);

	case 11:
		check_point(45);

		ercd = iras_tex(TASK1, 0x0100);
		check_ercd(ercd, E_OK);

		check_point(46);

		return(E_OK);

		check_point(0);
	}
	check_point(0);
	return(E_SYS);
}

static uint_t	extsvc2_count = 0;

ER_UINT
extsvc2_routine(intptr_t par1, intptr_t par2, intptr_t par3,
								intptr_t par4, intptr_t par5, ID cdmid)
{
	ER		ercd;

	switch (++extsvc2_count) {
	case 1:
		check_point(38);

		ercd = cal_svc(TFN_EXTSVC1, 0, 0, 0, 0, 0);
		check_ercd(ercd, E_OK);

		check_point(41);

		return(E_OK);

		check_point(0);
	}
	check_point(0);
	return(E_SYS);
}

void
task1(intptr_t exinf)
{
	ER		ercd;

	check_point(1);

	ercd = cal_svc(TFN_EXTSVC1, 0, 0, 0, 0, 0);
	check_ercd(ercd, E_OK);

	check_point(6);

	ercd = unl_cpu();
	check_ercd(ercd, E_OK);

	check_point(8);

	ercd = cal_svc(TFN_EXTSVC1, 0, 0, 0, 0, 0);
	check_ercd(ercd, E_OK);

	check_point(10);

	ercd = unl_cpu();
	check_ercd(ercd, E_OK);

	check_point(11);

	ercd = cal_svc(TFN_EXTSVC1, 0, 0, 0, 0, 0);
	check_ercd(ercd, E_OK);

	check_point(13);

	ercd = unl_cpu();
	check_ercd(ercd, E_OK);

	check_point(14);

	ercd = cal_svc(TFN_EXTSVC1, 0, 0, 0, 0, 0);
	check_ercd(ercd, E_OK);

	check_point(16);

	ercd = unl_cpu();
	check_ercd(ercd, E_OK);

	ercd = chg_ipm(TIPM_ENAALL);
	check_ercd(ercd, E_OK);

	check_point(18);

	ercd = act_tsk(TASK2);
	check_ercd(ercd, E_OK);

	ercd = slp_tsk();
	check_ercd(ercd, E_OK);

	check_point(20);

	ercd = ras_tex(TASK2, 0x0008);
	check_ercd(ercd, E_OK);

	ercd = loc_cpu();
	check_ercd(ercd, E_OK);

	check_point(21);

	ercd = unl_cpu();
	check_ercd(ercd, E_OK);

	check_point(22);

	ercd = cal_svc(TFN_EXTSVC1, 0, 0, 0, 0, 0);
	check_ercd(ercd, E_OK);

	check_point(24);

	ercd = cal_svc(TFN_EXTSVC1, 0, 0, 0, 0, 0);
	check_ercd(ercd, E_OK);

	check_point(28);

	ercd = cal_svc(TFN_EXTSVC1, 0, 0, 0, 0, 0);
	check_ercd(ercd, E_OK);

	check_point(31);

	ercd = cal_svc(TFN_EXTSVC1, 0, 0, 0, 0, 0);
	check_ercd(ercd, E_OK);

	check_point(34);

	ercd = cal_svc(TFN_EXTSVC1, 0, 0, 0, 0, 0);
	check_ercd(ercd, E_OK);

	check_point(37);

	ercd = cal_svc(TFN_EXTSVC2, 0, 0, 0, 0, 0);
	check_ercd(ercd, E_OK);

	check_point(43);

	ercd = ena_tex();
	check_ercd(ercd, E_OK);

	ercd = chg_ipm(TIPM_ENAALL);
	check_ercd(ercd, E_OK);

	RAISE_CPU_EXCEPTION;

	check_point(0);
}

static uint_t	tex_task1_count = 0;

void
tex_task1(TEXPTN texptn, intptr_t exinf)
{
	ER		ercd;

	switch (++tex_task1_count) {
	case 1:
		check_point(7);
		check_assert(texptn == 0x0001);
		check_state(false, false, TIPM_ENAALL, false, false, true);

		return;

		check_point(0);

	case 2:
		check_point(17);
		check_assert(texptn == 0x0006);
		check_state(false, false, TIPM_ENAALL, false, false, true);

		return;

		check_point(0);

	case 3:
		check_point(27);
		check_assert(texptn == 0x0010);
		check_state(false, false, TIPM_ENAALL, false, false, true);

		return;

		check_point(0);

	case 4:
		check_point(42);
		check_assert(texptn == 0x00e0);
		check_state(false, false, TIPM_ENAALL, false, false, true);

		return;

		check_point(0);

	case 5:
		check_point(48);
		check_assert(texptn == 0x0100);
		check_state(false, false, TIPM_ENAALL, false, false, true);

		check_point(49);

		ercd = ext_tsk();
		check_ercd(ercd, E_OK);

		check_point(0);
	}
	check_point(0);
}

void
task2(intptr_t exinf)
{
	ER		ercd;

	check_point(19);

	ercd = ena_tex();
	check_ercd(ercd, E_OK);

	ercd = wup_tsk(TASK1);
	check_ercd(ercd, E_OK);

	check_point(0);
}

void
tex_task2(TEXPTN texptn, intptr_t exinf)
{
	ER		ercd;

	check_point(50);
	check_assert(texptn == 0x0008);
	check_state(false, false, TIPM_ENAALL, false, false, true);

	check_finish(51);

	check_point(0);
}
