#
#  @(#) $Id: Makefile.prc 2115 2011-06-22 02:18:51Z ertl-honda $
# 

#
#		Makefile Υץå¸SH34ѡ
#

# 
#  ץå¸ǥ쥯ȥ̾ 
# 
PRCDIR = $(SRCDIR)/arch/$(PRC)_$(TOOL)/

#
#  ѥ륪ץ
#
COPTS := $(COPTS)
LDFLAGS := -nostdlib $(LDFLAGS) 
CDEFS := $(CDEFS) -DTOPPERS_LABEL_ASM
LIBS := $(LIBS) -lgcc

#
#  ץåμ˱ѥ륪ץ
#
ifeq ($(PRC_ARCH), SH3)
	COPTS := $(COPTS) -m3
endif

ifeq ($(PRC_ARCH), SH4)
	ifeq ($(FPU_ENABLE),true)
		ifeq ($(FPU_MODE),SINGLE)
			COPTS := $(COPTS) -m4-single
		else
		ifeq ($(FPU_MODE),SINGLE_ONLY)
			COPTS := $(COPTS) -m4-single-only
		else
		ifeq ($(FPU_MODE),DOUBLE)
			COPTS := $(COPTS) -m4
		endif
		endif
		endif
	else
		COPTS := $(COPTS) -m4-nofpu
	endif
endif

ifeq ($(PRC_ARCH), SH4A)
	ifeq ($(FPU_ENABLE),true)
		ifeq ($(FPU_MODE),SINGLE)
			COPTS := $(COPTS) -m4a-single
		else
		ifeq ($(FPU_MODE),SINGLE_ONLY)
			COPTS := $(COPTS) -m4a-single-only
		else
		ifeq ($(FPU_MODE),DOUBLE)
			COPTS := $(COPTS) -m4a
		endif
		endif
		endif
	else
		COPTS := $(COPTS) -m4a-nofpu
	endif
endif

#
#  FPUѤ
#
ifeq ($(FPU_ENABLE),true)
CDEFS := $(CDEFS) -DFPU_ENABLE
CFG1_OUT_LDFLAGS := $(CFG1_OUT_LDFLAGS) -lgcc
endif

ifeq ($(FPU_MODE),SINGLE)
CDEFS := $(CDEFS) -DFPU_SINGLE
endif

ifeq ($(FPU_MODE),SINGLE_ONLY)
CDEFS := $(CDEFS) -DFPU_SINGLE_ONLY
endif

ifeq ($(FPU_MODE),DOUBLE)
CDEFS := $(CDEFS) -DFPU_DOUBLE
endif


#
#  ͥ˴ؤ
#
KERNEL_DIR := $(KERNEL_DIR) $(PRCDIR)
KERNEL_ASMOBJS := $(KERNEL_ASMOBJS) prc_support.o
KERNEL_COBJS := $(KERNEL_COBJS) prc_config.o prc_timer.o

#
#  ե졼طѿ
#
CFG_TABS := $(CFG_TABS) --cfg1-def-table $(PRCDIR)/prc_def.csv

#
#  ¸ط
#
cfg1_out.c: $(PRCDIR)/prc_def.csv
kernel_cfg.timestamp: $(PRCDIR)/prc.tf
